﻿
'Program Name:              Assignment 4
'Student Name:              Evan Lyons
'My submission of this program indicates that I have neither recieved nor
'given substantial assistance in writing this program.

Public Class Form1


    Private Sub btnPayment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPayment.Click

        lstLoanInfo.Items.Clear() ' Allows for new data to be entered if calculate payment is clicked

        Dim dblItem As String = txtItem.Text
        Dim dblYear As Double = CDbl(txtYear.Text)
        Dim dblCost As Double
        If IsNumeric(dblCost) = True Then
            dblCost = CDbl(CStr(txtCost.Text))
        Else
            MessageBox.Show("Incorrect currency input", "Error") 'Validates currency
        End If
        Dim dblNumYears As Double = CDbl(txtNumYears.Text)
        Dim dblInterestSum As Double

        lstLoanInfo.Items.Add("Description: " & dblItem) ' displays the inputs in the list box
        lstLoanInfo.Items.Add("Year of loan: " & dblYear)
        lstLoanInfo.Items.Add("Loan: " & dblCost)
        lstLoanInfo.Items.Add("No of payments: " & dblNumYears)


        Dim dblIntRate As Double
        Select Case lstIntRate.Text ' Allows interest rate to be used as a numeric value
            Case "5%"
                dblIntRate = 0.05
            Case "6%"
                dblIntRate = 0.06
            Case "7%"
                dblIntRate = 0.07
            Case "8%"
                dblIntRate = 0.08
            Case "9%"
                dblIntRate = 0.09
            Case "10%"
                dblIntRate = 0.1
            Case Else
                MessageBox.Show("User must select interest rate", "Error") ' input validation for the interest rate
                lstLoanInfo.Items.Clear()
        End Select

        lstLoanInfo.Items.Add("Interest Rate: " & FormatPercent(dblIntRate, 2))  'calculates and formats interest rate
        Dim dblPayment As Double
        dblPayment = -Pmt(dblIntRate, dblNumYears, dblCost) 'formula for payment
        lstLoanInfo.Items.Add("Payment: " & FormatCurrency(dblPayment, 2))  'output for payment
        lstLoanInfo.Items.Add("")

        'Year One Calculations
        Dim dblRateYearOne As Double = dblCost * dblIntRate 'Formula for yearly int rate
        lstLoanInfo.Items.Add("Amount of interest during " & dblYear & ": " & FormatCurrency(dblRateYearOne, 2))
        Dim dblLoanPaidOne As Double = dblPayment - dblRateYearOne 'Formula for amount of loan paid 
        lstLoanInfo.Items.Add("Amount of interest during " & dblYear & ": " & FormatCurrency(dblLoanPaidOne, 2))
        Dim dblRemaining As Double = dblCost - dblLoanPaidOne 'Formula for remaining principle
        lstLoanInfo.Items.Add("Remaining principle at end of " & dblYear & ": " & FormatCurrency(dblRemaining, 2))
        lstLoanInfo.Items.Add("")

        'Remaining year calculations
        Dim dblFirstYr As Double = dblYear
        Dim dblLastYr As Double = dblYear + (dblNumYears - 1)
        For dblLoopYears As Double = (dblFirstYr + 1) To dblLastYr Step 1 'loop for years


            'Output for Interest
            Dim dblRateYear As Double = dblRemaining * dblIntRate
            lstLoanInfo.Items.Add("Amount of interest during " & dblLoopYears & ": " & FormatCurrency(dblRateYear, 2))
            dblInterestSum += dblRateYear

            'Output for amount of loan paid
            Dim dblLoanPaid As Double = dblPayment - dblRateYear
            lstLoanInfo.Items.Add("Amount of loan paid during " & dblLoopYears & ": " & FormatCurrency(dblLoanPaid, 2))

            'Output for remaining principle 
            dblRemaining -= dblLoanPaid
            lstLoanInfo.Items.Add("Remaining principle at end of " & dblLoopYears & ": " & FormatCurrency(dblRemaining, 2))
            lstLoanInfo.Items.Add("")

        Next

        lstLoanInfo.Items.Add("Total interest paid for life of loan: " & FormatCurrency(dblInterestSum + dblRateYearOne))

        'Reverse the order of the item purchased
        Dim intVertical As Integer = CInt(txtItem.TextLength)
        For intPurchased As Integer = (intVertical - 1) To (intVertical - intVertical) Step -1
            lstReverse.Items.Add(txtItem.Text(intPurchased))
        Next



    End Sub

    Private Sub lstLoanInfo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstLoanInfo.SelectedIndexChanged
        lstLoanInfo.Items.Clear()
    End Sub




    Private Sub btnExit_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub
End Class
